<?php
/**
* 邮件发送类
*
* @version        $Id: email.class.php 2016年3月31日 10:00  weimeng
* @package        WMCMS
* @copyright      Copyright (c) 2015 WeiMengCMS, Inc.
* @link           http://www.weimengcms.com
* @uptime 		  2015年12月22日 10:38  weimeng
*
*/
class email{
	static public $pageArr = '';

	//获得邮件服务器
	function GetSmtp()
	{
		return C('config.web.smtp');
	}
	//获得邮件账号
	function GetName()
	{
		return C('config.web.emailname');
	}
	//获得邮件密码
	function GetPsw()
	{
		return str::Encrypt( C('config.web.emailpsw') , 'D' , C('config.api.system.api_apikey'));
	}
	
	
	//发送测试邮件
	function Test()
	{
		$nickName = 'admin';
		$title = '邮件发送测试！';
		$content = '这是一封测试邮件，如果您收到此邮件说明你的邮件配置完全正确可以使用了！';
		return $this->SendEmail($this->GetName(), $nickName , $title , $content);
	}
	
	
	//发送测试邮件
	function SendGetPsw($email , $name , $title , $content)
	{
		return $this->SendEmail($email, $name , $title , $content);
	}
	
	
	/**
	 * 发送邮件
	 * @param 参数1，必填，收件人地址
	 * @param 参数2，必填，收件人姓名
	 * @param 参数3，必填，邮件标题
	 * @param 参数4，必填，邮件内容
	 */
	function SendEmail( $email , $nickname , $title , $content){
		require("Mailer/class.phpmailer.php"); //下载的文件必须放在该文件所在目录
		//require("Mailer/class.smtp.php"); //下载的文件必须放在该文件所在目录
		$mail = new PHPMailer(); //建立邮件发送类

		$mail->SMTPDebug = 0;//调试模式
		$mail->IsSMTP(); // 使用SMTP方式发送
		$mail->CharSet="UTF-8";
		$mail->Host = $this->GetSmtp(); // 您的企业邮局域名
		$mail->SMTPAuth = true; // 启用SMTP验证功能
		$mail->Username = $this->GetName(); // 邮局用户名(请填写完整的email地址)
		$mail->Password = $this->GetPsw(); // 邮局密码

		/**
		 * 注意：端口必须用等号连着写，不能有任何的空格。否则无法发出邮件
		 */
		if( $this->GetSmtp() == 'smtp.qq.com' )
		{
			$mail->SMTPSecure = "ssl";
			$mail->Port=465;
		}
		else
		{
			$mail->SMTPSecure = "ssl";
			$mail->Port=465;
		}
		//邮件发送者email地址
		$mail->From = $this->GetName();
		$mail->FromName = C('config.web.webname');
		//收件人地址，可以替换成任何想要接收邮件的email信箱,格式是AddAddress("收件人email","收件人姓名"
		$mail->AddAddress( $email , $nickname);
		//是否使用HTML格式
		$mail->IsHTML(true);
		//邮件标题
		$mail->Subject = $title;
		//邮件内容
		$mail->Body = $content;
		
		$mail->AltBody = "这是一封系统自动发送的注册邮件,请勿回复！"; //附加信息，可以省略

		if( !$mail->Send() )
		{
			return false;
		}
		else
		{
			return true;
		}
	}
}
?>